SystemOrganization addCategory: #'LanguageAspects-Core'!
SystemOrganization addCategory: #'LanguageAspects-DSL'!
SystemOrganization addCategory: #'LanguageAspects-Tests'!
SystemOrganization addCategory: #'LanguageAspects-Examples'!

!PPParser methodsFor: '*languageaspects' stamp: 'lr 10/20/2008 13:38'!
small
	^ LATokenParser on: self! !

CUCompositeParser subclass: #LASmalltalkGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Core'!

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 10/20/2008 10:24'!
array
	${ small , statements , $} small! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 14:43'!
arrayLiteral
	'#(' small , arrayLiteralElement star , $) small! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 14:43'!
arrayLiteralArray
	($# optional , $() small , arrayLiteralElement star , $) small! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:11'!
arrayLiteralChar
	charToken! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:10'!
arrayLiteralElement
	arrayLiteralTrue / arrayLiteralFalse / arrayLiteralNil / arrayLiteralNumber / arrayLiteralChar / arrayLiteralString / arrayLiteralSymbol / arrayLiteralArray! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:12'!
arrayLiteralFalse
	falseToken! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:12'!
arrayLiteralNil
	nilToken! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:12'!
arrayLiteralNumber
	numberToken! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:12'!
arrayLiteralString
	stringToken! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 13:50'!
arrayLiteralSymbol
	($# optional , symbol) small! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:11'!
arrayLiteralTrue
	trueToken! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/23/2008 20:27'!
assignment
	variable , assignmentToken! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/17/2008 14:43'!
assignmentToken
	(':=' / '_') small! !

!LASmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 10/17/2008 15:07'!
binary
	($~ / $- / $!! / $@ / $% / $& / $* / $+ / $= / $\ / $| / $? / $/ / $> / $< / $,) , 
	($~ /      $!! / $@ / $% / $& / $* / $+ / $= / $\ / $| / $? / $/ / $> / $< / $,) star! !

!LASmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 9/23/2008 18:43'!
binaryExpression
	unaryExpression , binaryMessage star! !

!LASmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 10/24/2008 10:54'!
binaryMessage
	(binaryToken , unaryExpression) ==> [ :nodes |
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!LASmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'lr 10/24/2008 10:48'!
binaryMethod
	(binaryToken , variable) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!LASmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'lr 10/24/2008 11:57'!
binaryPragma
	(binaryToken , arrayLiteralElement) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/17/2008 14:43'!
binaryToken
	binary small! !

!LASmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 10/17/2008 14:43'!
block
	$[ small , blockArguments , sequence , $] small! !

!LASmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 10/20/2008 17:15'!
blockArgument
	$: small , variable! !

!LASmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 10/17/2008 12:54'!
blockArguments
	blockArgumentsMany / blockArgumentsNone! !

!LASmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 10/17/2008 14:43'!
blockArgumentsMany
	blockArgument plus , $| small! !

!LASmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 10/17/2008 12:55'!
blockArgumentsNone
	PPEpsilonParser new! !

!LASmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 9/23/2008 19:29'!
cascadeExpression
	keywordExpression , cascadeMessage star! !

!LASmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 10/24/2008 11:25'!
cascadeMessage
	$; small , (keywordMessage / binaryMessage / unaryMessage)! !

!LASmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 10/17/2008 14:22'!
char
	$$ , #any! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/13/2008 17:15'!
charLiteral
	charToken! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/17/2008 14:43'!
charToken
	char small! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/23/2008 20:27'!
expression
	assignment star , cascadeExpression! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/13/2008 17:23'!
falseLiteral
	falseToken! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/17/2008 14:43'!
falseToken
	'false' small! !

!LASmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 10/17/2008 14:22'!
identifier
	#letter , #word star! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/17/2008 14:43'!
identifierToken
	identifier small! !

!LASmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 10/17/2008 14:23'!
keyword
	identifier , $:! !

!LASmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 10/24/2008 11:11'!
keywordExpression
	binaryExpression , keywordMessage optional! !

!LASmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 10/24/2008 10:55'!
keywordMessage
	(keywordToken , binaryExpression) plus ==> [ :nodes |
		Array
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!LASmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'lr 10/24/2008 10:47'!
keywordMethod
	(keywordToken , variable) plus ==> [ :nodes |
		Array
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!LASmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'lr 10/24/2008 11:57'!
keywordPragma
	(keywordToken , arrayLiteralElement) plus ==> [ :nodes |
		Array
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/17/2008 14:43'!
keywordToken
	keyword small! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 10/17/2008 11:11'!
literal
	trueLiteral / falseLiteral / nilLiteral / charLiteral / numberLiteral / stringLiteral / symbolLiteral / arrayLiteral! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 10/24/2008 10:40'!
method
	methodDeclaration , methodSequence! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 10/24/2008 10:48'!
methodDeclaration
	keywordMethod / unaryMethod / binaryMethod! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 10/20/2008 13:44'!
methodSequence
	pragmas , temporaries , pragmas , statements ==> [ :nodes | Array with: nodes first , nodes third with: nodes second with: nodes fourth ]! !

!LASmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 9/23/2008 21:06'!
multiword
	keyword plus! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/17/2008 14:43'!
multiwordToken
	multiword small! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/13/2008 17:16'!
nilLiteral
	nilToken! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/17/2008 14:43'!
nilToken
	'nil' small! !

!LASmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 10/20/2008 16:48'!
number
	($- optional , #digit) and , [ :stream |
		[ Number readFrom: stream ]
			on: Error
			do: [ :err | PPFailure reason: err messageText at: stream position ] ]
		asParser! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/13/2008 17:17'!
numberLiteral
	numberToken! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/17/2008 14:43'!
numberToken
	number small! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 10/17/2008 15:39'!
parens
	$( small , expression , $) small! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 10/20/2008 17:13'!
pragma
	$< small , (keywordPragma / unaryPragma / binaryPragma) , $> small! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 10/20/2008 10:31'!
pragmas
	pragma star! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 10/17/2008 15:41'!
primary
	variable / literal / block / parens / array! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 10/23/2008 17:09'!
return
	$^ small , expression! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/23/2008 20:00'!
sequence
	temporaries , statements! !

!LASmalltalkGrammar methodsFor: 'accessing' stamp: 'lr 10/17/2008 14:20'!
start
	method end! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 10/23/2008 14:05'!
statements
	  (return , $. small optional ==> [ :nodes | Array with: nodes first ])
	/ (expression wrapped , $. small , statements ==> [ :nodes | nodes third copyWithFirst: nodes first ])
	/ (expression wrapped , $. small optional ==> [ :nodes | Array with: nodes first ])
	/ ($. small optional ==> [ :node | Array new ])! !

!LASmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 10/17/2008 14:23'!
string
	$' , (($' , $') / $' negate) star , $'! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/13/2008 17:17'!
stringLiteral
	stringToken! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/17/2008 14:43'!
stringToken
	string small! !

!LASmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 10/23/2008 13:50'!
symbol
	unary / binary / multiword / string! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 13:50'!
symbolLiteral
	($# , symbol) small! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/23/2008 13:49'!
symbolToken
	symbol small! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 10/23/2008 13:52'!
temporaries
	  ($| small , variable star , $| small) 	optional ==> [ :nodes | nodes isNil ifTrue: [ Array new ] ifFalse: [ nodes ] ]! !

!LASmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 10/13/2008 17:18'!
trueLiteral
	trueToken! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/17/2008 14:43'!
trueToken
	'true' small! !

!LASmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 10/17/2008 14:23'!
unary
	identifier , $: not! !

!LASmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 9/23/2008 19:07'!
unaryExpression
	primary , unaryMessage star! !

!LASmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 10/24/2008 10:55'!
unaryMessage
	(unaryToken) ==> [ :node | 
		Array 
			with: (Array with: node) 
			with: (Array new) ]! !

!LASmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'lr 10/24/2008 10:55'!
unaryMethod
	(identifierToken) ==> [ :node | 
		Array
			with: (Array with: node)
			with: (Array new) ]! !

!LASmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'lr 10/24/2008 11:56'!
unaryPragma
	(identifierToken) ==> [ :node | 
		Array
			with: (Array with: node)
			with: (Array new) ]! !

!LASmalltalkGrammar methodsFor: 'token' stamp: 'lr 10/17/2008 14:43'!
unaryToken
	unary small! !

!LASmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/23/2008 20:02'!
variable
	identifierToken! !

LASmalltalkGrammar subclass: #LASmalltalkHighlighter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Core'!

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 16:41'!
arrayLiteralChar
	super arrayLiteralChar ==> [ :token | token -> Color magenta ]! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 16:42'!
arrayLiteralFalse
	super arrayLiteralFalse ==> [ :token | token -> Color cyan ]! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 16:42'!
arrayLiteralNil
	super arrayLiteralNil ==> [ :token | token -> Color cyan ]! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 16:42'!
arrayLiteralNumber
	super arrayLiteralNumber ==> [ :token | token -> Color magenta ]! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 16:51'!
arrayLiteralString
	super arrayLiteralString ==> [ :token | token -> Color magenta ]! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 16:42'!
arrayLiteralSymbol
	super arrayLiteralSymbol ==> [ :token | token -> Color magenta ]! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 16:42'!
arrayLiteralTrue
	super arrayLiteralTrue ==> [ :token | token -> Color cyan ]! !

!LASmalltalkHighlighter methodsFor: 'token' stamp: 'lr 10/24/2008 12:23'!
assignmentToken
	super assignmentToken ==> [ :token | token -> TextEmphasis bold ]! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 11:27'!
charLiteral
	super charLiteral ==> [ :token | token -> Color magenta ]! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 11:28'!
falseLiteral
	super falseLiteral ==> [ :token | token -> Color cyan ]! !

!LASmalltalkHighlighter methodsFor: 'grammar' stamp: 'lr 10/24/2008 12:18'!
methodDeclaration
	super methodDeclaration ==> [ :nodes | self paint: nodes with: TextEmphasis bold ]! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 11:28'!
nilLiteral
	super nilLiteral  ==> [ :token | token -> Color cyan ]! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 11:28'!
numberLiteral
	super numberLiteral ==> [ :token | token -> Color magenta ]! !

!LASmalltalkHighlighter methodsFor: 'private' stamp: 'lr 10/24/2008 12:21'!
paint: anObject with: aTextAttribute
	anObject isVariableBinding ifTrue: [
		^ anObject value isCollection
			ifTrue: [ anObject value: (anObject value copyWith: aTextAttribute) ]
			ifFalse: [ anObject value: (Array with: anObject value with: aTextAttribute) ] ].
	(anObject isCollection and: [ anObject isString not ])
		ifTrue: [ ^ anObject collect: [ :each | self paint: each with: aTextAttribute ] ].
	^ anObject -> aTextAttribute! !

!LASmalltalkHighlighter methodsFor: 'grammar' stamp: 'lr 10/24/2008 12:18'!
pragma
	super pragma ==> [ :nodes | self paint: nodes with: Color gray ]
	! !

!LASmalltalkHighlighter methodsFor: 'grammar' stamp: 'lr 10/24/2008 12:25'!
return
	super return ==> [ :nodes | nodes at: 1 put: nodes first -> TextEmphasis bold; yourself ]! !

!LASmalltalkHighlighter methodsFor: 'accessing' stamp: 'lr 10/24/2008 10:37'!
start
	"The highlighter should be as firendly as possible, don't expect to parser everything."
	
	method! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 11:28'!
stringLiteral
	super stringLiteral ==> [ :token | token -> Color magenta ]! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 15:38'!
symbolLiteral
	super symbolLiteral ==> [ :token | token -> Color magenta ]! !

!LASmalltalkHighlighter methodsFor: 'grammar-literals' stamp: 'lr 10/23/2008 11:28'!
trueLiteral
	super trueLiteral ==> [ :token | token -> Color cyan ]! !

!LASmalltalkHighlighter methodsFor: 'grammar' stamp: 'lr 10/23/2008 16:41'!
variable
	super variable ==> [ :token |
		(#('self' 'super' 'thisContext') includes: token value)
			ifTrue: [ token -> Color cyan ]
			ifFalse: [ token -> Color blue ] ]! !

LASmalltalkGrammar subclass: #LASmalltalkParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Core'!

!LASmalltalkParser methodsFor: 'grammar' stamp: 'lr 10/17/2008 15:47'!
array
	super array ==> [ :nodes | RBArrayNode leftBrace: nodes first rightBrace: nodes last statements: nodes second ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:06'!
arrayLiteral
	super arrayLiteral ==> [ :nodes | RBLiteralNode value: nodes second asArray ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 14:21'!
arrayLiteralArray
	super arrayLiteralArray ==> [ :nodes | nodes second asArray ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:19'!
arrayLiteralChar
	super arrayLiteralChar ==> [ :token | token value second ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:15'!
arrayLiteralFalse
	super arrayLiteralFalse ==> [ :token | false ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:14'!
arrayLiteralNil
	super arrayLiteralNil ==> [ :token | nil ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:14'!
arrayLiteralNumber
	super arrayLiteralNumber ==> [ :token | Number readFrom: token value ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/24/2008 11:50'!
arrayLiteralString
	super arrayLiteralString ==> [ :token | self buildString: token value ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/24/2008 11:51'!
arrayLiteralSymbol
	super arrayLiteralSymbol ==> [ :token | (self buildString: token value) asSymbol ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:15'!
arrayLiteralTrue
	super arrayLiteralTrue ==> [ :token | true ]! !

!LASmalltalkParser methodsFor: 'grammar' stamp: 'lr 9/26/2008 11:33'!
assignment
	super assignment ==> #first! !

!LASmalltalkParser methodsFor: 'grammar-messages' stamp: 'lr 10/24/2008 11:00'!
binaryExpression
	super binaryExpression map: [ :receiver :messages | self build: receiver messages: messages ]! !

!LASmalltalkParser methodsFor: 'grammar-blocks' stamp: 'lr 10/17/2008 11:59'!
block
	super block ==> [ :nodes | RBBlockNode arguments: nodes second body: nodes third ]! !

!LASmalltalkParser methodsFor: 'grammar-blocks' stamp: 'lr 10/17/2008 12:00'!
blockArgument
	super blockArgument ==> #second! !

!LASmalltalkParser methodsFor: 'grammar-blocks' stamp: 'lr 10/17/2008 12:07'!
blockArgumentsMany
	super blockArgumentsMany ==> #first! !

!LASmalltalkParser methodsFor: 'grammar-blocks' stamp: 'lr 10/17/2008 12:05'!
blockArgumentsNone
	super blockArgumentsNone ==> [ :token | Array new ]! !

!LASmalltalkParser methodsFor: 'private' stamp: 'lr 10/24/2008 11:54'!
build: aNode assignment: anArray
	^ anArray isEmpty
		ifTrue: [ aNode ]
		ifFalse: [ 
			anArray reverse
				inject: aNode
				into: [ :result :each | RBAssignmentNode variable: each value: result ] ]! !

!LASmalltalkParser methodsFor: 'private' stamp: 'lr 10/24/2008 11:36'!
build: aNode cascade: anArray
	| messages |
	^ (anArray isNil or: [ anArray isEmpty ])
		ifTrue: [ aNode ]
		ifFalse: [
			messages := OrderedCollection new: anArray size + 1.
			messages addLast: aNode.
			anArray  do: [ :each |
				messages addLast: (self
					build: aNode receiver
					messages: (Array with: each second)) ].
			RBCascadeNode messages: messages ]! !

!LASmalltalkParser methodsFor: 'private' stamp: 'lr 10/24/2008 11:28'!
build: aNode messages: anArray
	^ (anArray isNil or: [ anArray isEmpty ])
		ifTrue: [ aNode ]
		ifFalse: [
			anArray inject: aNode into: [ :receiver :message |
				message isNil
					ifTrue: [ receiver ]
					ifFalse: [
						RBMessageNode
							receiver: receiver
							selectorParts: message first 
							arguments: message second ] ] ]! !

!LASmalltalkParser methodsFor: 'private' stamp: 'lr 10/24/2008 11:37'!
build: aTempCollection sequence: aStatementCollection
	^ (aTempCollection isEmpty
		ifTrue: [ RBSequenceNode new ]
		ifFalse: [ RBSequenceNode leftBar: aTempCollection first temporaries: aTempCollection second rightBar: aTempCollection last ])
			statements: aStatementCollection;
			yourself ! !

!LASmalltalkParser methodsFor: 'private' stamp: 'lr 10/24/2008 12:12'!
buildPragma: anArray
	^ Pragma
		keyword: (anArray first 
			inject: String new
			into: [ :result :each | result , each value ])
				asSymbol
		arguments: anArray second! !

!LASmalltalkParser methodsFor: 'private' stamp: 'lr 10/24/2008 11:51'!
buildString: aString
	(aString isEmpty not and: [ aString first = $# ])
		ifTrue: [ ^ (self buildString: aString allButFirst) asSymbol ].
	(aString isEmpty or: [ aString first ~= $' or: [ aString last ~= $' ] ])
		ifTrue: [ ^ aString ].
	^ (aString copyFrom: 2 to: aString size - 1)
		copyReplaceAll: '''''' with: ''''! !

!LASmalltalkParser methodsFor: 'grammar-messages' stamp: 'lr 10/24/2008 11:51'!
cascadeExpression
	super cascadeExpression map: [ :receiver :messages | self build: receiver cascade: messages ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:16'!
charLiteral
	super charLiteral ==> [ :token | RBLiteralNode literalToken: token value: token value second ]! !

!LASmalltalkParser methodsFor: 'grammar' stamp: 'lr 10/24/2008 11:55'!
expression
	super expression map: [ :variables :expression | self build: expression assignment: variables ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/17/2008 11:16'!
falseLiteral
	super falseLiteral ==> [ :token | RBLiteralNode literalToken: token value: false ]! !

!LASmalltalkParser methodsFor: 'grammar-messages' stamp: 'lr 10/24/2008 11:23'!
keywordExpression
	super keywordExpression map: [ :receiver :message | self build: receiver messages: (Array with: message) ]! !

!LASmalltalkParser methodsFor: 'grammar' stamp: 'lr 10/24/2008 11:38'!
method
	super method map: [ :declaration :body |
		declaration pragmas: body first.
		declaration body: (self
			build: body second
			sequence: body third).
		declaration ]! !

!LASmalltalkParser methodsFor: 'grammar' stamp: 'lr 10/24/2008 10:50'!
methodDeclaration
	super methodDeclaration ==> [ :nodes | RBMethodNode selectorParts: nodes first arguments: nodes second ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/13/2008 17:16'!
nilLiteral
	super nilLiteral ==> [ :token | RBLiteralNode literalToken: token value: nil ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/13/2008 17:17'!
numberLiteral
	super numberLiteral ==> [ :token | RBLiteralNode literalToken: token value: (Number readFrom: token value) ]! !

!LASmalltalkParser methodsFor: 'grammar' stamp: 'lr 10/17/2008 15:40'!
parens
	super parens ==> #second! !

!LASmalltalkParser methodsFor: 'grammar' stamp: 'lr 10/24/2008 12:12'!
pragma
	super pragma ==> [ :nodes |
		| pragma |
		pragma := self buildPragma: nodes second.
		RBPragmaNode
			pragma: pragma
			spec: pragma keyword
			start: nodes first start
			stop: nodes last stop
			firstToken: nodes first
			lastToken: nodes last ]! !

!LASmalltalkParser methodsFor: 'grammar' stamp: 'lr 10/23/2008 17:09'!
return
	super return map: [ :token :expression | RBReturnNode value: expression ]! !

!LASmalltalkParser methodsFor: 'grammar' stamp: 'lr 10/24/2008 11:38'!
sequence
	super sequence map: [ :temporaries :statements | self build: temporaries sequence: statements ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/24/2008 11:50'!
stringLiteral
	super stringLiteral ==> [ :token | RBLiteralNode literalToken: token value: (self buildString: token value) ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/24/2008 11:50'!
symbolLiteral
	super symbolLiteral ==> [ :node | RBLiteralNode literalToken: node value: (self buildString: node value) ]! !

!LASmalltalkParser methodsFor: 'grammar-literals' stamp: 'lr 10/13/2008 17:28'!
trueLiteral
	super trueLiteral ==> [ :token | RBLiteralNode literalToken: token value: true ]! !

!LASmalltalkParser methodsFor: 'grammar-messages' stamp: 'lr 10/24/2008 11:01'!
unaryExpression
	super unaryExpression map: [ :receiver :messages | self build: receiver messages: messages ]! !

!LASmalltalkParser methodsFor: 'grammar' stamp: 'lr 9/23/2008 20:02'!
variable
	super variable ==> [ :token | RBVariableNode identifierToken: token ]! !

Object subclass: #LAAspect
	instanceVariableNames: 'active environments concerns pointcut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Core'!

LAAspect class
	instanceVariableNames: 'Default'!

LAAspect class
	instanceVariableNames: 'Default'!

!LAAspect class methodsFor: 'querying' stamp: 'lr 10/23/2008 17:12'!
activeForSelector: aSymbol in: aClass do: aBlock
	aClass isNil 
		ifTrue: [ ^ Array new ].
	^ self allSubclassesDo: [ :aspect |
		(aspect default isActive and: [ aspect default includesSelector: aSymbol in: aClass ]) 
			ifTrue: [ aBlock value: aspect default ] ]! !

!LAAspect class methodsFor: 'accessing' stamp: 'lr 10/10/2008 15:03'!
default
	^ Default ifNil: [ Default := self new ]! !

!LAAspect class methodsFor: 'initialization' stamp: 'lr 10/10/2008 15:08'!
reset
	Default := nil.
	self subclasses do: [ :each | each reset ]! !

!LAAspect class methodsFor: 'initialization' stamp: 'lr 10/10/2008 15:03'!
unload
	self default active: false! !

!LAAspect methodsFor: 'accessing' stamp: 'lr 10/10/2008 15:09'!
active: aBoolean
	"Enable or disable the receiving language aspect."
	
	active = aBoolean
		ifTrue: [ ^ self ].
	active := aBoolean.
	self recompile! !

!LAAspect methodsFor: 'scoping' stamp: 'lr 10/23/2008 09:59'!
addClassScope: aClass
	^ self addScope: (BrowserEnvironment new forClasses: (Array with: aClass))! !

!LAAspect methodsFor: 'concerns' stamp: 'lr 10/23/2008 11:09'!
addConcern: aConcern
	concerns := concerns copyWith: aConcern.
	^ aConcern! !

!LAAspect methodsFor: 'scoping' stamp: 'lr 10/23/2008 09:59'!
addPackageScope: aString
	^ self addScope: (BrowserEnvironment new forPackageNamed: aString)! !

!LAAspect methodsFor: 'scoping' stamp: 'lr 10/23/2008 09:59'!
addPragmaScope: aKeyword
	^ self addScope: (BrowserEnvironment new forPragmas: (Array with: aKeyword))! !

!LAAspect methodsFor: 'scoping' stamp: 'lr 10/23/2008 09:59'!
addScope: anEnvironment
	"Add a new scope to the receiving aspect and incrementally update all code."

	environments := environments
		copyWith: anEnvironment.
	self isActive
		ifTrue: [ self recompile: anEnvironment ].	
	^ anEnvironment! !

!LAAspect methodsFor: 'accessing' stamp: 'lr 10/10/2008 15:21'!
concerns
	"Answer a collection of concerns."
	
	^ concerns! !

!LAAspect methodsFor: 'accessing' stamp: 'lr 10/23/2008 09:44'!
environment
	"Answer a a composed environment."
	
	^ environments isEmpty
		ifTrue: [ BrowserEnvironment new not ]
		ifFalse: [ environments fold: [ :first :second | first | second ] ]! !

!LAAspect methodsFor: 'accessing' stamp: 'lr 10/10/2008 15:05'!
environments
	"Answer a collection of environments."
	
	^ environments! !

!LAAspect methodsFor: 'testing' stamp: 'lr 10/23/2008 11:12'!
includesSelector: aSelector in: aClass
	"Answer wether the receiving aspect is active in the given context or not."

	^ self environment includesSelector: aSelector in: aClass! !

!LAAspect methodsFor: 'initialization' stamp: 'lr 10/23/2008 17:22'!
initialize
	active := true.
	pointcut := LAPointcut on: self.
	concerns := environments := #()! !

!LAAspect methodsFor: 'testing' stamp: 'lr 10/10/2008 15:01'!
isActive
	"Answer wether the receiving aspect is active or not."
	
	^ active! !

!LAAspect methodsFor: 'accessing' stamp: 'lr 10/23/2008 17:25'!
name
	"A human readable name of the aspect."
	
	^ self class name! !

!LAAspect methodsFor: 'accessing' stamp: 'lr 10/27/2008 11:20'!
parser
	"Answer the parser of the receiver."
	
	self subclassResponsibility! !

!LAAspect methodsFor: 'accessing' stamp: 'lr 10/13/2008 13:41'!
pointcut
	"Answer the pointcut of the reciever."
	
	^ pointcut! !

!LAAspect methodsFor: 'actions' stamp: 'lr 10/20/2008 15:53'!
recompile
	"Recompile all the affected methods in the selected enviornments."

	self recompile: self environment! !

!LAAspect methodsFor: 'actions' stamp: 'lr 10/10/2008 14:43'!
recompile: anEnvironment
	"Recompile all the affected methods in anEnvironment."
	
	anEnvironment classesAndSelectorsDo: [ :class :selector | class recompile: selector ]! !

!LAAspect methodsFor: 'actions' stamp: 'lr 10/23/2008 09:56'!
refresh
	self isActive
		ifTrue: [ self recompile ]! !

!LAAspect methodsFor: 'actions' stamp: 'lr 10/23/2008 10:01'!
reset
	self initialize.
	self refresh! !

!LAAspect methodsFor: 'public' stamp: 'lr 10/23/2008 17:15'!
weave: aParser
	"Weave aParser with all the applicable concerns."
	
	self concerns do: [ :concern |
		(concern isApplicable: aParser)
			ifTrue: [ self pointcut weave: aParser concern: concern ] ]! !

LAAspect subclass: #LAPathAspect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Examples'!

!LAPathAspect class methodsFor: 'initialization' stamp: 'lr 10/27/2008 11:00'!
initialize
	self default reset! !

!LAPathAspect methodsFor: 'initialization' stamp: 'lr 10/27/2008 14:55'!
initialize
	super initialize.
	self pointcut before; choice; name: #cascadeExpression.
	self addConcern: (LAHighlighter on: [ :tokens |
		tokens flatten collect: [ :each |
			each -> Color tan ] ]).
	self addConcern: (LATransformer on: [ :tokens |
		QQObjectNode new ]).
	self addClassScope: LAPathAspectTest! !

!LAPathAspect methodsFor: 'accessing' stamp: 'lr 10/27/2008 15:02'!
parser
	| identifierToken binaryExpression pathPart |
	identifierToken := PPUnresolvedParser named: #identifierToken.
	binaryExpression := PPUnresolvedParser named: #binaryExpression.
	pathPart := identifierToken , ($[ asParser small , binaryExpression , $] asParser small) optional.
	^ pathPart , ($: asParser small , pathPart) plus! !

LAAspect subclass: #LARegexpAspect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Examples'!

!LARegexpAspect class methodsFor: 'initialization' stamp: 'lr 10/27/2008 11:51'!
initialize
	self default reset! !

!LARegexpAspect methodsFor: 'initialization' stamp: 'lr 10/27/2008 11:39'!
initialize
	super initialize.
	self pointcut after; choice; name: #literal.
	self addConcern: (LAHighlighter attribute: Color orange).
	self addConcern: (LATransformer on: [ :token |
		QQObjectNode 
			literalToken: token 
			value: (token value copyFrom: 2 to: token size - 1)
				asRegex ]).
	self addClassScope: LARegexpAspectTest! !

!LARegexpAspect methodsFor: 'accessing' stamp: 'lr 10/27/2008 11:23'!
parser
	^ ($/ asParser , $/ asParser negate star , $/ asParser) small! !

Object subclass: #LAConcern
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Core'!

!LAConcern class methodsFor: 'instance-creation' stamp: 'lr 10/27/2008 12:02'!
on: aBlock
	^ self new setBlock: aBlock! !

!LAConcern methodsFor: 'public' stamp: 'lr 10/27/2008 12:01'!
apply: anObject
	^ block value: anObject! !

!LAConcern methodsFor: 'testing' stamp: 'lr 10/23/2008 16:58'!
isApplicable: aParser
	^ false! !

!LAConcern methodsFor: 'initialization' stamp: 'lr 10/27/2008 12:01'!
setBlock: aBlock
	block := aBlock! !

!LAConcern methodsFor: 'weaving' stamp: 'lr 10/27/2008 12:02'!
weave: aParser
	^ aParser ==> block! !

LAConcern subclass: #LAHighlighter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Core'!

!LAHighlighter class methodsFor: 'instance-creation' stamp: 'lr 10/27/2008 12:03'!
attribute: anAttribute
	^ self on: [ :token | token -> anAttribute ]! !

!LAHighlighter methodsFor: 'testing' stamp: 'lr 10/23/2008 16:58'!
isApplicable: aParser
	^ aParser class = LASmalltalkHighlighter! !

LAConcern subclass: #LATransformer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Core'!

!LATransformer methodsFor: 'testing' stamp: 'lr 10/24/2008 13:44'!
isApplicable: aParser
	^ aParser class = LASmalltalkParser! !

Object subclass: #LAPointcut
	instanceVariableNames: 'aspect name action class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Core'!

!LAPointcut class methodsFor: 'instance-creation' stamp: 'lr 10/23/2008 17:22'!
on: anAspect
	^ self new setAspect: anAspect! !

!LAPointcut methodsFor: 'accessing-place' stamp: 'lr 10/10/2008 15:36'!
after
	"Insert the new parser and concern after the name rule."
	
	action := #after! !

!LAPointcut methodsFor: 'accessing-place' stamp: 'lr 10/10/2008 15:35'!
around
	"Insert the concern around the named rule."
	
	action := #around! !

!LAPointcut methodsFor: 'accessing-place' stamp: 'lr 10/10/2008 15:36'!
before
	"Insert the new parser and concern before the name rule."
	
	action := #before! !

!LAPointcut methodsFor: 'accessing-list' stamp: 'lr 10/10/2008 15:39'!
choice
	"Use a choice to combine the two grammars."
	
	class := PPChoiceParser! !

!LAPointcut methodsFor: 'initialization' stamp: 'lr 10/27/2008 11:21'!
initialize
	self after.
	self choice.
	self name: #start! !

!LAPointcut methodsFor: 'accessing' stamp: 'lr 10/13/2008 13:46'!
name: aSymbol
	"The name of the rule to identify."
	
	name := aSymbol asSymbol! !

!LAPointcut methodsFor: 'accessing-place' stamp: 'lr 10/10/2008 15:36'!
replace
	"Replace the named rule with the given parser and concern."

	action := #replace! !

!LAPointcut methodsFor: 'accessing-list' stamp: 'lr 10/10/2008 15:39'!
sequence
	"Use a sequence to combine the two grammars."
	
	class := PPSequenceParser! !

!LAPointcut methodsFor: 'initialization' stamp: 'lr 10/23/2008 17:22'!
setAspect: anAspect
	aspect := anAspect! !

!LAPointcut methodsFor: 'public' stamp: 'lr 10/27/2008 11:37'!
weave: aParser concern: aConcern
	| parser original copied |
	parser := aspect parser walk: [ :each |
		each isUnresolved
			ifTrue: [ each def: (aParser perform: each name) ] ].
	original := aParser perform: name.
	copied := original copy.
	original def: (action = #replace
		ifTrue: [ aConcern weave: parser ]
		ifFalse: [
			action = #around
				ifTrue: [ aConcern weave: copied ]
				ifFalse: [
					action = #before
						ifTrue: [ class with: (aConcern weave: parser) with: copied ]
						ifFalse: [
							action = #after
								ifTrue: [ class with: copied with: (aConcern weave: parser) ]
								ifFalse: [ self error: 'Invalid pointcut action.' ] ] ] ])! !

!RBAssignmentNode methodsFor: '*languageaspects-override' stamp: 'lr 10/17/2008 15:10'!
assignmentOperator
	^ self defaultAssignmentOperator! !

!ProtoObject methodsFor: '*languageaspects' stamp: 'lr 10/24/2008 13:25'!
languageAspectsHighlight
	<highlight: 1>
	
	^ LAHighlightAction new! !

!ProtoObject methodsFor: '*languageaspects' stamp: 'lr 10/24/2008 13:41'!
languageAspectsParser
	<parse: 1>
	
	^ LAParseAction new! !

PPTokenParser subclass: #LATokenParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Core'!

!LATokenParser methodsFor: 'hooks' stamp: 'lr 10/23/2008 16:33'!
consumeSpaces: aStream
	[ super consumeSpaces: aStream.
	  aStream peek == $" ] whileTrue: [
		aStream next.
		[ aStream atEnd not and: [ aStream next = $" ] ] 
			whileFalse ]! !

DSLRule subclass: #LAHighlightAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-DSL'!

!LAHighlightAction methodsFor: 'visiting' stamp: 'lr 10/24/2008 13:37'!
acceptDsl: aVisitor
	| parser offset tokens |
	parser := LASmalltalkHighlighter new.
	LAAspect
		activeForSelector: aVisitor selector 
		in: aVisitor theClass
		do: [ :aspect | aspect weave: parser ].
	aVisitor text
		removeAttributesFrom: aVisitor scopeStart
		to: aVisitor scopeStop.
	offset := aVisitor scopeStart - 1.
	tokens := parser
		parse: aVisitor scopedText readStream
		ifError: [ :err | ^ self ].
	tokens flattenedDo: [ :each |
		(each isVariableBinding and: [ each key class = PPToken ]) ifTrue: [ 
			aVisitor
				scopeFrom: offset + each key start
				to: offset + each key stop
				with: nil visit: each value ] ]! !

DSLRule subclass: #LAParseAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-DSL'!

!LAParseAction methodsFor: 'visiting' stamp: 'lr 10/24/2008 13:54'!
acceptDsl: aVisitor
	| parser |
	aVisitor doIt ifTrue: [ ^ nil ].
	parser := LASmalltalkParser new.
	LAAspect
		activeForSelector: aVisitor selector
		in: aVisitor theClass
		do: [ :aspect | aspect weave: parser ].
	^ parser
		parse: aVisitor stream
		ifError: [ :err | self error: err reason ]! !

TestCase subclass: #LAGrammarTests
	instanceVariableNames: 'parser result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Tests'!

LAGrammarTests subclass: #LACompilerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Tests'!

!LACompilerTests methodsFor: 'accessing' stamp: 'lr 10/24/2008 13:24'!
parserClass
	^ LASmalltalkParser! !

!LACompilerTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testArgumentsBlock1
	super testArgumentsBlock1.
	self assert: result isBlock.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testArgumentsBlock2
	super testArgumentsBlock2.
	self assert: result isBlock.
	self assert: result arguments size = 2.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name = 'b'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testArgumentsBlock3
	super testArgumentsBlock3.
	self assert: result isBlock.
	self assert: result arguments size = 3.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name = 'b'.
	self assert: result arguments third isVariable.
	self assert: result arguments third name = 'c'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral1
	super testArrayLiteral1.
	self assert: result isLiteral.
	self assert: result value = #()! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral10
	super testArrayLiteral10.
	self assert: result isLiteral.
	self assert: result value = #(#(1 2 ) #(1 2 3 ) )! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral2
	super testArrayLiteral2.
	self assert: result isLiteral.
	self assert: result value = #(1 )! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral3
	super testArrayLiteral3.
	self assert: result isLiteral.
	self assert: result value = #(1 2 )! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral4
	super testArrayLiteral4.
	self assert: result isLiteral.
	self assert: result value = #(true false nil )! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral5
	super testArrayLiteral5.
	self assert: result isLiteral.
	self assert: result value = #($a )! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral6
	super testArrayLiteral6.
	self assert: result isLiteral.
	self assert: result value = #(1.2 )! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 16:03'!
testArrayLiteral7
	super testArrayLiteral7.
	self assert: result isLiteral.
	self assert: result value = #(size #at: at:put: #'==').
	result value do: [ :each | self assert: each isSymbol ]! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 16:01'!
testArrayLiteral8
	super testArrayLiteral8.
	self assert: result isLiteral.
	self assert: result value = #('baz').
	self assert: result value first isString.
	self assert: result value first isSymbol not! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 16:02'!
testArrayLiteral9
	super testArrayLiteral9.
	self assert: result isLiteral.
	self assert: result value = #((1) 2)! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testAssignment1
	super testAssignment1.
	self assert: result isLiteral.
	self assert: result value = 1! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testAssignment2
	super testAssignment2.
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name = 'a'.
	self assert: result value isLiteral.
	self assert: result value value = 1! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testAssignment3
	super testAssignment3.
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name = 'a'.
	self assert: result value isAssignment.
	self assert: result value variable isVariable.
	self assert: result value variable name = 'b'.
	self assert: result value value isLiteral.
	self assert: result value value value = 1! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testAssignment4
	super testAssignment4.
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name = 'a'.
	self assert: result value isLiteral.
	self assert: result value value = 1! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testAssignment5
	super testAssignment5.
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name = 'a'.
	self assert: result value isAssignment.
	self assert: result value variable isVariable.
	self assert: result value variable name = 'b'.
	self assert: result value value isLiteral.
	self assert: result value value value = 1! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testBinaryExpression1
	super testBinaryExpression1.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result receiver value = 1.
	self assert: result arguments size = 1.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 2! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testBinaryExpression2
	super testBinaryExpression2.
	self assert: result isMessage.
	self assert: result receiver isMessage.
	self assert: result receiver receiver isLiteral.
	self assert: result receiver receiver value = 1.
	self assert: result receiver arguments size = 1.
	self assert: result receiver arguments first isLiteral.
	self assert: result receiver arguments first value = 2.
	self assert: result arguments size = 1.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 3! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testBinaryMethod1
	super testBinaryMethod1.
	self assert: result isMethod.
	self assert: result selector = #+.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testBinaryMethod2
	super testBinaryMethod2.
	self assert: result isMethod.
	self assert: result selector = #+.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testBinaryMethod3
	super testBinaryMethod3.
	self assert: result isMethod.
	self assert: result selector = #+.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testBinaryMethod4
	super testBinaryMethod4.
	self assert: result isMethod.
	self assert: result selector = #+.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries size = 1.
	self assert: result body statements size = 1! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testCascadeExpression1
	super testCascadeExpression1.
	self assert: result isCascade.
	self assert: result receiver isLiteral.
	self assert: result messages size = 2.
	self assert: result messages first receiver = result receiver.
	self assert: result messages first selector = #abs.
	self assert: result messages second receiver = result receiver.
	self assert: result messages second selector = #negated! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testCascadeExpression2
	super testCascadeExpression2.
	self assert: result isCascade.
	self assert: result receiver isMessage.
	self assert: result receiver receiver isLiteral.
	self assert: result receiver receiver value = 1.
	self assert: result receiver selector = #abs.
	self assert: result messages size = 3.
	self assert: result messages first receiver = result receiver.
	self assert: result messages first selector = #negated.
	self assert: result messages second receiver = result receiver.
	self assert: result messages second selector = #raisedTo:.
	self assert: result messages third receiver = result receiver.
	self assert: result messages third selector = #negated! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testCascadeExpression3
	super testCascadeExpression3.
	self assert: result isCascade.
	self assert: result receiver isLiteral.
	self assert: result receiver value = 1.
	self assert: result messages size = 2.
	self assert: result messages first receiver = result receiver.
	self assert: result messages first selector = #+.
	self assert: result messages first arguments size = 1.
	self assert: result messages second receiver = result receiver.
	self assert: result messages second selector = #-.
	self assert: result messages second arguments size = 1! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testCharLiteral1
	super testCharLiteral1.
	self assert: result isLiteral.
	self assert: result value = $a! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testCharLiteral2
	super testCharLiteral2.
	self assert: result isLiteral.
	self assert: result value = Character space! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testCharLiteral3
	super testCharLiteral3.
	self assert: result isLiteral.
	self assert: result value = $$! !

!LACompilerTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testComplexBlock1
	super testComplexBlock1.
	self assert: result isBlock.
	self assert: result arguments size = 1.
	self assert: result body temporaries size = 1.
	self assert: result body statements size = 1! !

!LACompilerTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testComplexBlock2
	super testComplexBlock2.
	self assert: result isBlock.
	self assert: result arguments size = 1.
	self assert: result body temporaries size = 1.
	self assert: result body statements size = 1! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordExpression1
	super testKeywordExpression1.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result receiver value = 1.
	self assert: result selector = #to:.
	self assert: result arguments size = 1.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 2! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordExpression2
	super testKeywordExpression2.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result selector = #to:by:.
	self assert: result arguments size = 2.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 2.
	self assert: result arguments second isLiteral.
	self assert: result arguments second value = 3! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordExpression3
	super testKeywordExpression3.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result selector = #to:by:do:.
	self assert: result arguments size = 3.
	self assert: result arguments first isLiteral.
	self assert: result arguments first value = 2.
	self assert: result arguments second isLiteral.
	self assert: result arguments second value = 3.
	self assert: result arguments third isLiteral.
	self assert: result arguments third value = 4! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordMethod1
	super testKeywordMethod1.
	self assert: result isMethod.
	self assert: result selector = #to:.
	self assert: result arguments size = 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordMethod2
	super testKeywordMethod2.
	self assert: result isMethod.
	self assert: result selector = #to:do:.
	self assert: result arguments size = 2.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name = 'b'.
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordMethod3
	super testKeywordMethod3.
	self assert: result isMethod.
	self assert: result selector = #to:do:by:.
	self assert: result arguments size = 3.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name = 'b'.
	self assert: result arguments third isVariable.
	self assert: result arguments third name = 'c'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordMethod4
	super testKeywordMethod4.
	self assert: result isMethod.
	self assert: result selector = #to:do:by:.
	self assert: result arguments size = 3.
	self assert: result arguments first isVariable.
	self assert: result arguments first name = 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name = 'b'.
	self assert: result arguments third isVariable.
	self assert: result arguments third name = 'c'.
	self assert: result body temporaries size = 1.
	self assert: result body statements size = 1! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral1
	super testNumberLiteral1.
	self assert: result isLiteral.
	self assert: result value = 0! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral10
	super testNumberLiteral10.
	self assert: result isLiteral.
	self assert: result value = 10! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral11
	super testNumberLiteral11.
	self assert: result isLiteral.
	self assert: result value = 511! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral12
	super testNumberLiteral12.
	self assert: result isLiteral.
	self assert: result value = 175! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral13
	super testNumberLiteral13.
	self assert: result isLiteral.
	self assert: result value = 202.9921875! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral14
	super testNumberLiteral14.
	self assert: result isLiteral.
	self assert: result value floor = -9! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral2
	super testNumberLiteral2.
	self assert: result isLiteral.
	self assert: result value = 0.1! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral3
	super testNumberLiteral3.
	self assert: result isLiteral.
	self assert: result value = 123! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral4
	super testNumberLiteral4.
	self assert: result isLiteral.
	self assert: result value = 123.456! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral5
	super testNumberLiteral5.
	self assert: result isLiteral.
	self assert: result value = 0! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral6
	super testNumberLiteral6.
	self assert: result isLiteral.
	self assert: result value = -0.1! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral7
	super testNumberLiteral7.
	self assert: result isLiteral.
	self assert: result value = -123! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral8
	super testNumberLiteral8.
	self assert: result isLiteral.
	self assert: result value = -123! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral9
	super testNumberLiteral9.
	self assert: result isLiteral.
	self assert: result value = -123.456! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testPragma1
	super testPragma1.
	self assert: result pragmas size = 1.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testPragma2
	super testPragma2.
	self assert: result pragmas size = 2.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testPragma3
	super testPragma3.
	self assert: result pragmas size = 1.
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testPragma4
	super testPragma4.
	self assert: result pragmas size = 1.
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testPragma5
	super testPragma5.
	self assert: result pragmas size = 2.
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testSequence1
	super testSequence1.
	self assert: result isSequence.
	self assert: result temporaries size = 1.
	self assert: result temporaries first isVariable.
	self assert: result temporaries first name = 'a'.
	self assert: result statements size = 2.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1.
	self assert: result statements second isLiteral.
	self assert: result statements second value = 2! !

!LACompilerTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testSimpleBlock1
	super testSimpleBlock1.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testSimpleBlock2
	super testSimpleBlock2.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSpecialLiteral1
	super testSpecialLiteral1.
	self assert: result isLiteral.
	self assert: result value = true! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSpecialLiteral2
	super testSpecialLiteral2.
	self assert: result isLiteral.
	self assert: result value = false! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSpecialLiteral3
	super testSpecialLiteral3.
	self assert: result isLiteral.
	self assert: result value = nil! !

!LACompilerTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testStatementBlock1
	super testStatementBlock1.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1! !

!LACompilerTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testStatementBlock2
	super testStatementBlock2.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries size = 1.
	self assert: result body statements size = 1! !

!LACompilerTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testStatementBlock3
	super testStatementBlock3.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries size = 2.
	self assert: result body statements size = 1! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testStatements1
	super testStatements1.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size = 1.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testStatements2
	super testStatements2.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size = 2.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1.
	self assert: result statements second isLiteral.
	self assert: result statements second value = 2! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testStatements3
	super testStatements3.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size = 3.
	self assert: result statements first isLiteral.
	self assert: result statements first value = 1.
	self assert: result statements second isLiteral.
	self assert: result statements second value = 2.
	self assert: result statements third isLiteral.
	self assert: result statements third value = 3! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testStringLiteral1
	super testStringLiteral1.
	self assert: result isLiteral.
	self assert: result value = ''! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testStringLiteral2
	super testStringLiteral2.
	self assert: result isLiteral.
	self assert: result value = 'ab'! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testStringLiteral3
	super testStringLiteral3.
	self assert: result isLiteral.
	self assert: result value = 'ab''cd'! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSymbolLiteral1
	super testSymbolLiteral1.
	self assert: result isLiteral.
	self assert: result value = #foo! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSymbolLiteral2
	super testSymbolLiteral2.
	self assert: result isLiteral.
	self assert: result value = #+! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSymbolLiteral3
	super testSymbolLiteral3.
	self assert: result isLiteral.
	self assert: result value = #key:! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSymbolLiteral4
	super testSymbolLiteral4.
	self assert: result isLiteral.
	self assert: result value = #key:value:! !

!LACompilerTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSymbolLiteral5
	super testSymbolLiteral5.
	self assert: result isLiteral.
	self assert: result value = #'testing-result'! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testTemporaries1
	super testTemporaries1.
	self assert: result isSequence.
	self assert: result temporaries size = 1.
	self assert: result temporaries first isVariable.
	self assert: result temporaries first name = 'a'.
	self assert: result statements isEmpty! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testTemporaries2
	super testTemporaries2.
	self assert: result isSequence.
	self assert: result temporaries size = 2.
	self assert: result temporaries first isVariable.
	self assert: result temporaries first name = 'a'.
	self assert: result temporaries second isVariable.
	self assert: result temporaries second name = 'b'.
	self assert: result statements isEmpty! !

!LACompilerTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testTemporaries3
	super testTemporaries3.
	self assert: result isSequence.
	self assert: result temporaries size = 3.
	self assert: result temporaries first isVariable.
	self assert: result temporaries first name = 'a'.
	self assert: result temporaries second isVariable.
	self assert: result temporaries second name = 'b'.
	self assert: result temporaries third isVariable.
	self assert: result temporaries third name = 'c'.
	self assert: result statements isEmpty! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryExpression1
	super testUnaryExpression1.
	self assert: result isMessage.
	self assert: result receiver isLiteral.
	self assert: result selector = #abs.
	self assert: result arguments isEmpty! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryExpression2
	super testUnaryExpression2.
	self assert: result isMessage.
	self assert: result receiver isMessage.
	self assert: result receiver receiver isLiteral.
	self assert: result receiver receiver value = 1.
	self assert: result receiver selector = #abs.
	self assert: result receiver arguments isEmpty.
	self assert: result selector = #negated.
	self assert: result arguments isEmpty! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryMethod1
	super testUnaryMethod1.
	self assert: result isMethod.
	self assert: result selector = #abs.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryMethod2
	super testUnaryMethod2.
	self assert: result isMethod.
	self assert: result selector = #abs.
	self assert: result arguments isEmpty.
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryMethod3
	super testUnaryMethod3.
	self assert: result isMethod.
	self assert: result selector = #abs.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size = 1! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryMethod4
	super testUnaryMethod4.
	self assert: result isMethod.
	self assert: result selector = #abs.
	self assert: result arguments isEmpty.
	self assert: result body temporaries size = 1.
	self assert: result body statements size = 1! !

!LACompilerTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryMethod5
	super testUnaryMethod5.
	self assert: result isMethod.
	self assert: result selector = #abs.
	self assert: result arguments isEmpty.
	self assert: result body temporaries size = 1.
	self assert: result body statements isEmpty! !

!LAGrammarTests methodsFor: 'parsing' stamp: 'lr 10/23/2008 15:53'!
parse: aString 
	self 
		parse: aString
		rule: #start! !

!LAGrammarTests methodsFor: 'parsing' stamp: 'lr 10/23/2008 15:53'!
parse: aString rule: aSymbol 
	| production |
	production := self parser 
		productionAt: aSymbol
		definition: [ self error: 'Invalid production ' , aSymbol printString ].
	result := production parse: aString asParserStream! !

!LAGrammarTests methodsFor: 'accessing' stamp: 'lr 10/23/2008 15:53'!
parser
	^ parser ifNil: [ parser := self parserClass new ]! !

!LAGrammarTests methodsFor: 'accessing' stamp: 'lr 10/24/2008 13:24'!
parserClass
	^ LASmalltalkGrammar! !

!LAGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testArgumentsBlock1
	self 
		parse: '[ :a | ]'
		rule: #block! !

!LAGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testArgumentsBlock2
	self 
		parse: '[ :a :b | ]'
		rule: #block! !

!LAGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testArgumentsBlock3
	self 
		parse: '[ :a :b :c | ]'
		rule: #block! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral1
	self 
		parse: '#()'
		rule: #arrayLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral10
	self 
		parse: '#((1 2) #(1 2 3))'
		rule: #arrayLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral2
	self 
		parse: '#(1)'
		rule: #arrayLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral3
	self 
		parse: '#(1 2)'
		rule: #arrayLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral4
	self 
		parse: '#(true false nil)'
		rule: #arrayLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral5
	self 
		parse: '#($a)'
		rule: #arrayLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral6
	self 
		parse: '#(1.2)'
		rule: #arrayLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 16:03'!
testArrayLiteral7
	self 
		parse: '#(size #at: at:put: #''=='')'
		rule: #arrayLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral8
	self 
		parse: '#(''baz'')'
		rule: #arrayLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testArrayLiteral9
	self 
		parse: '#((1) 2))'
		rule: #arrayLiteral! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testAssignment1
	self 
		parse: '1'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testAssignment2
	self 
		parse: 'a := 1'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testAssignment3
	self 
		parse: 'a := b := 1'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testAssignment4
	self 
		parse: 'a _ 1'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testAssignment5
	self 
		parse: 'a _ b _ 1'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testBinaryExpression1
	self 
		parse: '1 + 2'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testBinaryExpression2
	self 
		parse: '1 + 2 + 3'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testBinaryMethod1
	self 
		parse: '+ a'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testBinaryMethod2
	self 
		parse: '+ a | b |'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testBinaryMethod3
	self 
		parse: '+ a b'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testBinaryMethod4
	self 
		parse: '+ a | b | c'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testCascadeExpression1
	self 
		parse: '1 abs; negated'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testCascadeExpression2
	self 
		parse: '1 abs negated; raisedTo: 12; negated'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testCascadeExpression3
	self 
		parse: '1 + 2; - 3'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testCharLiteral1
	self 
		parse: '$a'
		rule: #charLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testCharLiteral2
	self 
		parse: '$ '
		rule: #charLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testCharLiteral3
	self 
		parse: '$$'
		rule: #charLiteral! !

!LAGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testComplexBlock1
	self 
		parse: '[ :a | | b | c ]'
		rule: #block! !

!LAGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testComplexBlock2
	self 
		parse: '[:a||b|c]'
		rule: #block! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordExpression1
	self 
		parse: '1 to: 2'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordExpression2
	self 
		parse: '1 to: 2 by: 3'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordExpression3
	self 
		parse: '1 to: 2 by: 3 do: 4'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordMethod1
	self 
		parse: 'to: a'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordMethod2
	self 
		parse: 'to: a do: b | c |'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordMethod3
	self 
		parse: 'to: a do: b by: c d'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testKeywordMethod4
	self 
		parse: 'to: a do: b by: c | d | e'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral1
	self 
		parse: '0'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral10
	self 
		parse: '10r10'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral11
	self 
		parse: '8r777'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral12
	self 
		parse: '16rAF'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral13
	self 
		parse: '16rCA.FE'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral14
	self 
		parse: '3r-22.2'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral2
	self 
		parse: '0.1'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral3
	self 
		parse: '123'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral4
	self 
		parse: '123.456'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral5
	self 
		parse: '-0'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral6
	self 
		parse: '-0.1'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral7
	self 
		parse: '-123'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral8
	self 
		parse: '-123'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testNumberLiteral9
	self 
		parse: '-123.456'
		rule: #numberLiteral! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testPragma1
	self 
		parse: 'method <foo>'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testPragma2
	self 
		parse: 'method <foo> <bar: 2>'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testPragma3
	self 
		parse: 'method | a | <foo>'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testPragma4
	self 
		parse: 'method <foo> | a |'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testPragma5
	self 
		parse: 'method <foo> | a | <bar>'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testSequence1
	self 
		parse: '| a | 1 . 2'
		rule: #sequence! !

!LAGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testSimpleBlock1
	self 
		parse: '[ ]'
		rule: #block! !

!LAGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testSimpleBlock2
	self 
		parse: '[ nil ]'
		rule: #block! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSpecialLiteral1
	self 
		parse: 'true'
		rule: #trueLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSpecialLiteral2
	self 
		parse: 'false'
		rule: #falseLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSpecialLiteral3
	self 
		parse: 'nil'
		rule: #nilLiteral! !

!LAGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testStatementBlock1
	self 
		parse: '[ nil ]'
		rule: #block! !

!LAGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testStatementBlock2
	self 
		parse: '[ | a | nil ]'
		rule: #block! !

!LAGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 10/23/2008 15:53'!
testStatementBlock3
	self 
		parse: '[ | a b | nil ]'
		rule: #block! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testStatements1
	self 
		parse: '1'
		rule: #sequence! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testStatements2
	self 
		parse: '1 . 2'
		rule: #sequence! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testStatements3
	self 
		parse: '1 . 2 . 3'
		rule: #sequence! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testStringLiteral1
	self 
		parse: ''''''
		rule: #stringLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testStringLiteral2
	self 
		parse: '''ab'''
		rule: #stringLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testStringLiteral3
	self 
		parse: '''ab''''cd'''
		rule: #stringLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSymbolLiteral1
	self 
		parse: '#foo'
		rule: #symbolLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSymbolLiteral2
	self 
		parse: '#+'
		rule: #symbolLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSymbolLiteral3
	self 
		parse: '#key:'
		rule: #symbolLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSymbolLiteral4
	self 
		parse: '#key:value:'
		rule: #symbolLiteral! !

!LAGrammarTests methodsFor: 'testing-literals' stamp: 'lr 10/23/2008 15:53'!
testSymbolLiteral5
	self 
		parse: '#''testing-result'''
		rule: #symbolLiteral! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testTemporaries1
	self 
		parse: '| a |'
		rule: #sequence! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testTemporaries2
	self 
		parse: '| a b |'
		rule: #sequence! !

!LAGrammarTests methodsFor: 'testing' stamp: 'lr 10/23/2008 15:53'!
testTemporaries3
	self 
		parse: '| a b c |'
		rule: #sequence! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryExpression1
	self 
		parse: '1 abs'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryExpression2
	self 
		parse: '1 abs negated'
		rule: #expression! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryMethod1
	self 
		parse: 'abs'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryMethod2
	self 
		parse: 'abs | a |'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryMethod3
	self 
		parse: 'abs a'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryMethod4
	self 
		parse: 'abs | a | b'
		rule: #method! !

!LAGrammarTests methodsFor: 'testing-messages' stamp: 'lr 10/23/2008 15:53'!
testUnaryMethod5
	self 
		parse: 'abs | a |'
		rule: #method! !

LAGrammarTests subclass: #LAHighlighterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Tests'!

!LAHighlighterTests methodsFor: 'accessing' stamp: 'lr 10/23/2008 15:53'!
parserClass
	^ LASmalltalkHighlighter! !

TestCase subclass: #LAPackagesTests
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Tests'!

!LAPackagesTests methodsFor: 'accessing' stamp: 'lr 10/24/2008 13:24'!
parser
	^ parser ifNil: [ parser := LASmalltalkParser new ]! !

!LAPackagesTests methodsFor: 'testing' stamp: 'lr 10/20/2008 17:08'!
testCollections
	self verifyClass: Collection.
	self verifyClass: SequenceableCollection.
	self verifyClass: OrderedCollection.
	self verifyClass: Array.
	self verifyClass: Dictionary.
	self verifyClass: Set.
	self verifyClass: Bag
	! !

!LAPackagesTests methodsFor: 'testing' stamp: 'lr 10/20/2008 17:09'!
testMorph
	self verifyClass: Morph! !

!LAPackagesTests methodsFor: 'testing' stamp: 'lr 10/20/2008 17:00'!
testPetitParser
	self verifyPackage: 'PetitParser'! !

!LAPackagesTests methodsFor: 'testing' stamp: 'lr 10/20/2008 17:03'!
testQuasiQuote
	self verifyPackage: 'QuasiQuote'! !

!LAPackagesTests methodsFor: 'private' stamp: 'lr 10/20/2008 17:03'!
verifyClass: aClass 
	aClass selectors
		do: [ :selector | self verifyClass: aClass selector: selector ]! !

!LAPackagesTests methodsFor: 'private' stamp: 'lr 10/20/2008 17:02'!
verifyClass: aClass selector: aSelector
	| source original other |
	source := aClass sourceCodeAt: aSelector.
	source isNil ifTrue: [ ^ self ].
	original := aClass parseTreeFor: aSelector.
	original isNil ifTrue: [ ^ self ].
	original nodesDo: [ :each | each comments: nil ].
	other := self parser parse: source asParserStream.
	other isFailure 
		ifTrue: [
			self
				assert: false
				description: other printString
				resumable: true ]
		ifFalse: [
			self
				assert: original formattedCode = other formattedCode
				description: source
				resumable: true ]! !

!LAPackagesTests methodsFor: 'private' stamp: 'lr 10/20/2008 17:01'!
verifyPackage: aString
	| package |
	package := PackageInfo named: aString.
	package classesAndMetaClasses
		do: [ :each | self verifyClass: each ]
		displayingProgress: 'Verifying ' , aString! !

TestCase subclass: #LAPathAspectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Examples'!

!LAPathAspectTest methodsFor: 'testing' stamp: 'lr 10/27/2008 14:53'!
testSpath
	self  self  self! !

TestCase subclass: #LARegexpAspectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LanguageAspects-Examples'!

!LARegexpAspectTest methodsFor: 'accessing' stamp: 'lr 10/27/2008 12:04'!
testRegexp
	self assert: (/foo.*/ matches: 'foobar').
	self assert: (/f.*b.*/ matches: 'foobar')! !
LAPathAspect initialize!
LARegexpAspect initialize!
